      PROGRAM SPA0301
C-DEMONSTRATION OF THE USE OF SUBROUTINE SPDFTR.
      DIMENSION X(0:7)
      COMPLEX Y(0:4)
      DATA X/-6.,-2.,0.,2.,4.,6.,3.,-1./
      CALL SPDFTR(X,Y,8)
      PRINT 1,(M,Y(M),M=0,4)
    1 FORMAT(' M    REAL      IMAGINARY'/(I2,2F10.4))
      STOP
      END
      PROGRAM SPA0302
C-DEMONSTRATION OF THE USE OF SUBROUTINE SPFFTR.
      DIMENSION X(0:9)
      DATA (X(M),M=0,7)/-6.,-2.,0.,2.,4.,6.,3.,-1./
      CALL SPFFTR(X,8)
      PRINT 1,(M,X(2*M),X(2*M+1),M=0,4)
    1 FORMAT(' M    REAL      IMAGINARY'/(I2,2F10.4))
      STOP
      END
      PROGRAM SPA0303
C-DEMONSTRATION OF THE USE OF SPIDTR.
      DIMENSION X1(0:7),X2(0:7)
      COMPLEX Y(0:4)
      DATA X1/-6.,-2.,0.,2.,4.,6.,3.,-1./
      CALL SPDFTR(X1,Y,8)
      CALL SPIDTR(Y,X2,8)
      PRINT 1,(K,X2(K),K+4,X2(K+4),K=0,3)
    1 FORMAT(' K  X(K)',11X,'K  X(K)'/(I2,F6.0,10X,I2,F6.0))
      STOP
      END
      PROGRAM SPA0304
C-DEMONSTRATION OF THE USE OF SUBROUTINE SPIFTR.
      DIMENSION X(0:9)
      DATA (X(M),M=0,7)/-6.,-2.,0.,2.,4.,6.,3.,-1./
      CALL SPFFTR(X,8)
      CALL SPIFTR(X,8)
      PRINT 1,(K,X(K),K+4,X(K+4),K=0,3)
    1 FORMAT(' K  X(K)',11X,'K  X(K)'/(I2,F6.0,10X,I2,F6.0))
      STOP
      END
      PROGRAM SPA0305
C-DEMONSTRATION OF THE USE OF SUBROUTINE SPDFTC.
      COMPLEX X1(0:3),X2(0:3)
      DATA X1/(2.,1.),(0.,2.),(1.,1.),(-1.,0.)/
      CALL SPDFTC(X1,X2,4,-1)
      CALL SPDFTC(X2,X1,4,+1)
      PRINT 1,(I,X1(I),X2(I),I=0,3)
    1 FORMAT(' I    X1(I)',19X,'X2(I)'/(I2,2F5.0,7X,2F12.7))
      STOP
      END
      PROGRAM SPA0306
C-DEMONSTRATION OF THE USE OF SUBROUTINE SPFFTC.
      COMPLEX X1(0:3),X2(0:3)
      DATA X1/(2.,1.),(0.,2.),(1.,1.),(-1.,0.)/
      CALL SPFFTC(X1,4,-1)
      DO 1 M=0,3
    1  X2(M)=X1(M)
      CALL SPFFTC(X1,4,+1)
      PRINT 2,(I,X1(I),X2(I),I=0,3)
    2 FORMAT(' I    X1(I)',19X,'X2(I)'/(I2,2F5.0,7X,2F12.7))
      STOP
      END
      PROGRAM SPA0307
C-DEMONSTRATION OF THE USE OF COMPLEX FUNCTION SPCOMP
      DIMENSION X(0:7)
      COMPLEX Y(0:4),SPCOMP
      DATA X/-6.,-2.,0.,2.,4.,6.,3.,-1./
      DO 1 M=0,4
    1  Y(M)=SPCOMP(X,8,M/8.)
      PRINT 2,(M,Y(M),M=0,4)
    2 FORMAT(' M    REAL      IMAGINARY'/(I2,2F10.4))
      STOP
      END
      PROGRAM SPA0401
C-GENERATES A PERIODOGRAM SIMILAR TO FIG. 4.1.
      DIMENSION X(0:31),Y(0:16),WORK(0:33)
      PI=4.*ATAN(1.)
      DO 1 K=0,31
       X(K)=SIN(2.*PI*K/8.)
    1 CONTINUE
      CALL SPPOWR(X,Y,WORK,31,16,1,0.,NSGMTS,IERROR)
      PRINT 2,NSGMTS,IERROR,Y
    2 FORMAT(' NSGMTS,IERROR=',2I4/' Y=',8F7.3/2X,9F7.3)
      CALL PFILE2(0.,1./32.,Y,17,1,'P0401A')
      STOP
      END
      PROGRAM SPA0402
C-POWER DENSITY SPECTRUM OF WHITE UNIFORM NOISE.
      DIMENSION X(0:999),Y(0:16),WORK(0:33)
      ISEED=12357
      EX2=0.
      DO 1 K=0,999
        X(K)=SQRT(12.*3.)*(SPRAND(ISEED)-.5)
        EX2=EX2+X(K)**2/1000.
    1 CONTINUE
      CALL SPPOWR(X,Y,WORK,999,16,1,0.0,NSGMTS,IERROR)
      TPOWER=(Y(0)+Y(16))/32.
      DO 2 M=1,15
        TPOWER=TPOWER+2.*Y(M)/32.
    2 CONTINUE
      PRINT 3,IERROR,NSGMTS,Y
    3 FORMAT(' IERROR,NSGMTS=',2I4/' Y=',8F7.3/2X,9F7.3)
      PRINT 4,EX2,TPOWER
    4 FORMAT(' ACTUAL POWER, ESTIMATED POWER:',2F7.3)
      CALL PFILE2(0.,1./32.,Y,17,1,'P0402A')
      STOP
      END
      PROGRAM SPA0403
C-POWER DENSITY SPECTRUM OF SINE WAVE IN WHITE UNIFORM NOISE.
      DIMENSION X(0:999),Y(0:16),WORK(0:33)
      PI=4.*ATAN(1.)
      ISEED=12357
      DO 1 K=0,999
        SIGNAL=SIN(3.*PI*K/16.)+0.5*SIN(7.*PI*K/16.)
        X(K)=SIGNAL+SQRT(12.*0.01)*(SPRAND(ISEED)-0.5)
    1 CONTINUE
      CALL SPPOWR(X,Y,WORK,999,16,1,0.5,NSGMTS,IERROR)
      DO 2 M=0,16
        Y(M)=10.*ALOG10(Y(M))
    2 CONTINUE
      CALL PFILE2(0.,1./32.,Y,17,1,'P0403A')
      STOP
      END
      PROGRAM SPA0404
C-TEST OF SPCROS, WITH RESULT SAME AS FOR SPA0401.
      DIMENSION X1(0:31),X2(0:31)
      COMPLEX Y(0:16),WORK(0:31)
      PI=4.*ATAN(1.)
      DO 1 K=0,31
        X1(K)=SIN(2.*PI*K/8.)
        X2(K)=SIN(2.*PI*K/8.)
    1 CONTINUE
      CALL SPCROS(X1,X2,Y,WORK,31,16,1,0.,NSGMTS,IERROR)
      PRINT 2,NSGMTS,IERROR,Y
    2 FORMAT(' NSGMTS,IERROR=',2I4/' Y=',8F7.3/(3X,8F7.3))
      STOP
      END
      PROGRAM SPA0405
C-TEST OF SPCROS:  ONE IMAGINARY COMPONENT.
      DIMENSION X1(0:31),X2(0:31)
      COMPLEX Y(0:8),WORK(0:15)
      PI=4.*ATAN(1.)
      DO 1 K=0,31
        X1(K)=COS(2.*PI*K/8.)
        X2(K)=SIN(2.*PI*K/8.)
    1 CONTINUE
      CALL SPCROS(X1,X2,Y,WORK,31,8,1,0.5,NSGMTS,IERROR)
      PRINT 2,NSGMTS,IERROR,Y
    2 FORMAT(' NSGMTS,IERROR=',2I4/' Y=',8F7.3/(3X,8F7.3))
      STOP
      END
      PROGRAM SPA0406
C-TEST OF SPCROS:  SAME SIGNAL PLUS INDEPENDENT NOISE.
      DIMENSION X1(0:999),X2(0:999),YABS(0:16)
      COMPLEX Y(0:16),WORK(0:31)
      PI=4.*ATAN(1.)
      ISEED=123
      DO 1 K=0,999
        SIGNAL=SIN(3.*PI*K/16.)+0.5*COS(7.*PI*K/16.)
        X1(K)=SIGNAL+SQRT(12.)*(SPRAND(ISEED)-0.5)
        X2(K)=SIGNAL+SQRT(12.)*(SPRAND(ISEED)-0.5)
    1 CONTINUE
      CALL SPCROS(X1,X2,Y,WORK,999,16,1,0.5,NSGMTS,IERROR)
      DO 2 M=0,16
        YABS(M)=REAL(Y(M))
    2 CONTINUE
      CALL PFILE2(0.,1./32.,YABS,17,1,'P0406A')
      STOP
      END
      PROGRAM SPA0501
C-DEMONSTRATION OF THE USE OF "SPGAIN" AT A SINGLE FREQUENCY.
      DIMENSION D(0:2),E(1:2),F(0:1)
      COMPLEX SPGAIN
      DATA B/2.0/, A/0.6/
      DATA D/0.3,0.8,0.2/, C/0.0/
      DATA F/0.0,-0.1/, E/0.0,0.9/
      PRINT 1,SPGAIN(B,A,0,1,0.25),SPGAIN(D,C,2,1,0.25),
     +        SPGAIN(F,E,1,2,0.25)
    1 FORMAT('      REAL      IMAG'/(2F10.4))
      STOP
      END
      PROGRAM SPA0502
C-AMPLITUDE GAIN PLOT FOR H(Z)=-0.1*Z/(Z**2+0.9).
      DIMENSION FREQ(0:300),AMP(0:300),F(0:1),E(1:2)
      COMPLEX SPGAIN
      DATA F/0.0,-0.1/, E/0.0,0.9/
      DO 1 I=0,300
        FREQ(I)=I*0.5/300.0
        AMP(I)=ABS(SPGAIN(F,E,1,2,FREQ(I)))
    1 CONTINUE
      CALL PFILE1(FREQ,AMP,301,1,'P0502A')
      STOP
      END
      PROGRAM SPA0503
C-PHASE SHIFT PLOT FOR H(Z)=-0.1*Z/(Z**2+0.9).
      DIMENSION FREQ(0:300),PHASE(0:300),F(0:1),E(1:2)
      COMPLEX SPGAIN,H
      DATA F/0.0,-0.1/, E/0.0,0.9/
      DO 1 I=0,300
        FREQ(I)=I*0.5/300.0
        H=SPGAIN(F,E,1,2,FREQ(I))
        PHASE(I)=ATAN2(AIMAG(H),REAL(H))
    1 CONTINUE
      CALL PFILE1(FREQ,PHASE,301,1,'P0503A')
      STOP
      END
      PROGRAM SPA0504
C-AMPLITUDE GAIN PLOT FOR THE CASCADE COMBINATION, H1*H2.
      DIMENSION FREQ(0:300),AMP(0:300),D(0:1),C(1:2)
      COMPLEX SPGAIN
      DATA B/0.2/, A/-0.8/, D/0.05,-0.1/, C/-0.95,0.9/
      DO 1 I=0,300
        FREQ(I)=I*0.5/300.0
        AMP(I)=ABS(SPGAIN(B,A,0,1,FREQ(I))*SPGAIN(D,C,1,2,FREQ(I)))
    1 CONTINUE
      CALL PFILE1(FREQ,AMP,301,1,'P0504A')
      STOP
      END
      PROGRAM SPA0505
C-AMPLITUDE GAIN PLOT FOR THE PARALLEL COMBINATION, H1+H2.
      DIMENSION FREQ(0:300),AMP(0:300),D(0:1),C(1:2)
      COMPLEX SPGAIN
      DATA B/0.2/, A/-0.8/, D/0.05,-0.1/, C/-0.95,0.9/
      DO 1 I=0,300
        FREQ(I)=I*0.5/300.0
        AMP(I)=ABS(SPGAIN(B,A,0,1,FREQ(I))+SPGAIN(D,C,1,2,FREQ(I)))
    1 CONTINUE
      CALL PFILE1(FREQ,AMP,301,1,'P0505A')
      STOP
      END
      PROGRAM SPA0506
C-PHASE SHIFT PLOTS FOR NONCAUSAL SYSTEMS H3(Z) AND H4(Z).
      DIMENSION FREQ(0:300),PHASE3(0:300),PHASE4(0:300),B(0:4)
      COMPLEX SPGAIN,H3,H4
      DATA B/-0.2,0.4,0.8,-0.4,0.2/
      PI=4.*ATAN(1.)
      DO 1 I=0,300
        FREQ(I)=I*0.5/300.0
        H3=SPGAIN(B,0.,4,1,FREQ(I))
        H4=SPGAIN(0.2,-0.8,0,1,FREQ(I))
        PHASE3(I)=ATAN2(AIMAG(H3),REAL(H3))+4.*PI*FREQ(I)
        PHASE4(I)=ATAN2(AIMAG(H4),REAL(H4))+2.*PI*FREQ(I)
    1 CONTINUE
      CALL SPUNWR(PHASE3,300,1)
      CALL PFILE1(FREQ,PHASE4,301,1,'P0506A')
      CALL PFILE1(FREQ,PHASE3,301,1,'P0506B')
      STOP
      END
      PROGRAM SPA0507
C-PLOT IMPULSE RESPONSE OF H(Z)=(0.05*Z**2-0.1*Z)/(Z**2-0.95*Z+0.9).
      DIMENSION X(0:1),Y(0:100),B(0:1),A(1:2)
      DATA X/1.0,0.0/, B/0.05,-0.1/, A/-0.95,0.9/
      CALL SPRESP(X,Y,1,100,B,A,1,2)
      CALL PFILE2(0.,1.,Y,101,1,'P0507A')
      STOP
      END
      PROGRAM SPA0508
C-PLOT THE UNIT STEP RESPONSE OF H1(Z)*H2(Z) IN CASCADE.
      DIMENSION X(0:1),Y1(0:100),Y2(0:100)
      DIMENSION D(0:1),C(1:2)
      DATA X/1.0,1.0/, D/0.05,-0.1/, C/-0.95,0.9/
      CALL SPRESP(X,Y1,1,100,0.2,-0.8,0,1)
      CALL SPRESP(Y1,Y2,100,100,D,C,1,2)
      CALL PFILE2(0.,1.,Y2,101,1,'P0508A')
      STOP
      END
      PROGRAM SPA0601
C-DEMONSTRATE THE USE OF SPFILT
      DIMENSION X(0:9),B(0:1),PX(0:1),A(1), PY(1)
      DATA X/1.,9*0./,PX/2*0./,PY/0./
      DATA B/1.,.5/,A/-.8/
      DATA LB/1/,LA/1/,N/10/
      CALL SPFILT(B,A,LB,LA,X,N,PX,PY,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPFILT ERROR = ',IERROR
      PRINT 100,(K,X(K),K=0,9)
100   FORMAT(' SAMPLE    OUTPUT '/(I5,F12.4))
      END
      PROGRAM SPA0602
C-DEMONSTRATE THE USE OF SPFILT FOR BLOCK MODE FILTERING.
      DIMENSION X(0:24),B(0:4),A(4),PX(0:4),PY(4)
      DIMENSION DATA(0:99)
      DATA B/.001836,.007344,.011016,.007344,.001836/
      DATA A/-3.0544,3.8291,-2.2925,.55075/
      DATA PX/5*0./,PY/4*0./,X/1.,24*0./
      DATA LB/4/,LA/4/,N/25/
      DO 5 NBLK=0,3
        CALL SPFILT(B,A,LB,LA,X,N,PX,PY,IERROR)
        IF(IERROR.NE.0) THEN
          PRINT *,' SPFILT ERROR = ',IERROR
          STOP
        ENDIF
        DO 4 K=0,24
          DATA(NBLK*25+K)=X(K)
          X(K)=0.
    4   CONTINUE
    5 CONTINUE
      CALL PFILE2(0.,1.,DATA,100,1,'P0602A')
      PRINT 100,(K,DATA(K),K=0,9)
100   FORMAT(' SAMPLE    RESPONSE '/(I6,F12.4))
      END
      PROGRAM SPA0603
C-DEMONSTRATE THE USE OF SPFLTR.
      DIMENSION X(0:99),Y(0:99),B(0:4),A(4),PX(0:4),PY(4)
      DATA B/.001836,.007344,.011016,.007344,.001836/
      DATA A/-3.0544,3.8291,-2.2925,.55075/
      DATA PX/5*0./,PY/4*0./,X/100*1./,Y/100*0./
      DATA LB/4/,LA/4/,N/100/
      CALL SPFLTR(B,A,LB,LA,X,N,Y,PX,PY,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' SPFLTR ERROR = ',IERROR
          STOP
        ENDIF
      CALL PFILE2(0.,1.,Y,100,1,'P0603A')
      END
      PROGRAM SPA0604
C-DEMONSTRATE THE USE OF SPCFLT.
      DIMENSION X(0:24),B(0:2,2),A(2,2),PX(0:2,2),PY(2,2),DATA(0:99)
      DATA X/1.,24*0./,PX/6*0./,PY/4*0./,LS/2/,NS/2/,N/25/
      DATA B/.001836,.003672,.001836,1.,2.,1./
      DATA A/-1.4996,.8482,-1.5548,.6493/
      DO 5 NBLK=0,3
        CALL SPCFLT(B,A,LS,NS,X,N,PX,PY,IERROR)
        IF(IERROR.NE.0) THEN
          PRINT *,' SPCFLT ERROR = ',IERROR
          STOP
        ENDIF
        DO 4 K=0,24
          DATA(NBLK*25+K)=X(K)
          X(K)=0.
    4   CONTINUE
    5 CONTINUE
      CALL PFILE2(0.,1.,DATA,100,1,'P0604A')
      PRINT 100,(K,DATA(K),K=0,9)
100   FORMAT(' SAMPLE    RESPONSE '/(I6,F12.4))
      END
      PROGRAM SPA0605
C-DEMONSTRATE THE USE OF SPPFLT.
      DIMENSION X(0:24),B(0:2,2),A(2,2),PX(0:2,2),PY(2,2),Y(0:24)
      DIMENSION DATA(0:99)
      DATA X/1.,24*0./,PX/6*0./,PY/4*0./,Y/25*0./,LS/2/,NS/2/,N/25/
      DATA B/.08327,.0239,0.,-.08327,-.0246,0./
      DATA A/-1.5658,.6549,-1.4934,.8392/
      DO 5 NBLK=0,3
        CALL SPPFLT(B,A,LS,NS,X,N,Y,PX,PY,IERROR)
        IF(IERROR.NE.0) THEN
          PRINT *,' SPPFLT ERROR = ',IERROR
          STOP
        ENDIF
        DO 4 K=0,24
          DATA(NBLK*25+K)=Y(K)
          X(K)=0.
    4   CONTINUE
    5 CONTINUE
      CALL PFILE2(0.,1.,DATA,100,1,'P0605A')
      PRINT 100,(K,DATA(K),K=0,9)
100   FORMAT(' SAMPLE    RESPONSE '/(I6,F12.4))
      END
      PROGRAM SPA0606
C-FIR FILTERING WITH SUBROUTINE SPFILT.
      DIMENSION X(0:9),B(0:4),PX(0:4),A(1),PY(1)
      DATA A/0./,PY/0./,X/1.,9*0./,PX/5*0./
      DATA B/1.,4.,6.,4.,1./,LB/4/,LA/1/,N/10/
      CALL SPFILT(B,A,LB,LA,X,N,PX,PY,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPFILT ERROR = ',IERROR
      PRINT 100,(K,X(K),K=0,9)
100   FORMAT(' SAMPLE    RESPONSE '/(I6,F12.4))
      END
      PROGRAM SPA0607
C-FIR FILTERING WITH SUBROUTINE SPCFLT.
      DIMENSION X(0:9),B(0:2,2),PX(0:2,2),A(2,2),PY(2,2)
      DATA A/4*0./,PY/4*0./,X/1.,9*0./,PX/6*0./
      DATA B/1.,2.,1.,1.,2.,1./,LS/2/,NS/2/,N/10/
      CALL SPCFLT(B,A,LS,NS,X,N,PX,PY,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPCFLT ERROR = ',IERROR
      PRINT 100,(K,X(K),K=0,9)
100   FORMAT(' SAMPLE    RESPONSE '/(I6,F12.4))
      END
      PROGRAM SPA0608
C-IIR FILTERING WITH SPLFLT - LATTICE STRUCTURE.
      DIMENSION X(0:24),B(0:4),A(4),PAST(0:4),WORK(0:4,3),DATA(0:99)
      REAL KAPPA(0:3),NU(0:4)
      DATA B/.001836,.007344,.011016,.007344,.001836/
      DATA A/-3.0544,3.8291,-2.2925,.55075/
      DATA PAST/5*0./,X/1.,24*0./,L/4/,N/25/
      CALL SPLTCF(B,A,L,KAPPA,NU,WORK,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' UNSTABLE TRANSFER FUNCTION H(Z)'
        STOP
      ENDIF
      DO 5 NBLK=0,3
        CALL SPLFLT(KAPPA,NU,L,X,N,PAST,IERROR)
        IF(IERROR.NE.0) THEN
          PRINT *,' SPLFLT ERROR = ',IERROR
          STOP
        ENDIF
        DO 4 K=0,24
          DATA(NBLK*25+K)=X(K)
          X(K)=0.
    4   CONTINUE
    5 CONTINUE
      CALL PFILE2(0.,1.,DATA,100,1,'P0608A')
      PRINT 100,KAPPA,NU
      PRINT 200,(K,DATA(K),K=0,9)
100   FORMAT(' KAPPA COEF = ',4F10.4/,' NU COEF =   ',5F10.4)
200   FORMAT(' SAMPLE    RESPONSE '/(I6,F12.4))
      END
      PROGRAM SPA0701
C-TRANSFORMATION VIA THE BILINIAR TRANSFORM.
      DIMENSION B(0:2),A(2),D(0:2),C(0:2),WORK(0:2,0:2)
      DATA D/0.1056,2*0./,C/0.1056,0.4595,1./,LN/2/
      CALL SPBILN(D,C,LN,B,A,WORK,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPBILN ERROR = ',IERROR
      PRINT 100,B,A
100   FORMAT(' B(Z) COEFFICIENTS:',3F10.4/
     +       ' A(Z) COEFFICIENTS:',2F10.4)
      END
      PROGRAM SPA0702
C-LOWPASS ANALOG TO LOWPASS DIGITAL SCALED IN FREQUENCY.
      DIMENSION D(0:2),C(0:2),B(0:2),A(2),WORK(0:2,0:2),AMP(0:500)
      COMPLEX SPGAIN
      DATA D/1.,2*0./,C/1.,1.41421,1./
      DATA IBAND/1/,FL/1000./,FH/0./T/.0001/,LN/2/
      FLN=FL*T
      FHN=FH*T
      CALL SPFBLT(D,C,LN,IBAND,FLN,FHN,B,A,WORK,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' SPFBLT ERROR = ',IERROR
        STOP
      ENDIF
      DO 1 I=0,500
        AMP(I)=ABS(SPGAIN(B,A,LN,LN,I*.5/500.))
    1 CONTINUE
      CALL PFILE2(0.,.01,AMP,501,1,'P0702A')
      PRINT 100,B,A
100   FORMAT(' B(Z) COEFFICIENTS:',3F10.4/
     +       ' A(Z) COEFFICIENTS:',2F10.4)
      END
      PROGRAM SPA0703
C-LOWPASS ANALOG TO HIGHPASS DIGITAL SCALED IN FREQUENCY.
      DIMENSION D(0:2),C(0:2),B(0:2),A(2),WORK(0:2,0:2),AMP(0:500)
      COMPLEX SPGAIN
      DATA D/1.,2*0./,C/1.,1.41421,1./
      DATA IBAND/2/,FL/3500./,FH/0./T/.0001/,LN/2/
      FLN=FL*T
      FHN=FH*T
      CALL SPFBLT(D,C,LN,IBAND,FLN,FHN,B,A,WORK,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' SPFBLT ERROR = ',IERROR
        STOP
      ENDIF
      DO 1 I=0,500
        AMP(I)=ABS(SPGAIN(B,A,LN,LN,I*.5/500.))
    1 CONTINUE
      CALL PFILE2(0.,.01,AMP,501,1,'P0703A')
      PRINT 100,B,A
100   FORMAT(' B(Z) COEFFICIENTS:',3F10.4/
     +       ' A(Z) COEFFICIENTS:',2F10.4)
      END
      PROGRAM SPA0704
C-LOWPASS ANALOG TO BANDPASS DIGITAL SCALED IN FREQUENCY.
      DIMENSION D(0:4),C(0:4),B(0:4),A(4),WORK(0:4,0:4),AMP(0:500)
      COMPLEX SPGAIN
      DATA D/1.,4*0./,C/1.,1.41421,1.,2*0./
      DATA IBAND/3/,FL/1500./,FH/3500./,T/.0001/,LN/4/
      FLN=FL*T
      FHN=FH*T
      CALL SPFBLT(D,C,LN,IBAND,FLN,FHN,B,A,WORK,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' SPFBLT ERROR = ',IERROR
        STOP
      ENDIF
      DO 1 I=0,500
        AMP(I)=ABS(SPGAIN(B,A,LN,LN,I*.5/500.))
    1 CONTINUE
      CALL PFILE2(0.,.01,AMP,501,1,'P0704A')
      PRINT 100,B,A
100   FORMAT(' B(Z) COEFFICIENTS:',5F10.4/
     +       ' A(Z) COEFFICIENTS:',4F10.4)
      END
      PROGRAM SPA0705
C-LOWPASS ANALOG TO BANDSTOP DIGITAL SCALED IN FREQUENCY.
      DIMENSION D(0:4),C(0:4),B(0:4),A(4),WORK(0:4,0:4),AMP(0:500)
      COMPLEX SPGAIN
      DATA D/1.,4*0./,C/1.,1.41421,1.,2*0./
      DATA IBAND/4/,FL/1500./,FH/3500./T/.0001/,LN/4/
      FLN=FL*T
      FHN=FH*T
      CALL SPFBLT(D,C,LN,IBAND,FLN,FHN,B,A,WORK,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' SPFBLT ERROR = ',IERROR
        STOP
      ENDIF
      DO 1 I=0,500
        AMP(I)=ABS(SPGAIN(B,A,LN,LN,I*.5/500.))
    1 CONTINUE
      CALL PFILE2(0.,.01,AMP,501,1,'P0705A')
      PRINT 100,B,A
100   FORMAT(' B(Z) COEFFICIENTS:',5F10.4/
     +       ' A(Z) COEFFICIENTS:',4F10.4)
      END
      PROGRAM SPA0706
C-DESIGN 6TH ORDER LOWPASS BUTTERWORTH FILTER.
      DIMENSION AMP(0:500),WORK(0:2,0:2),D(0:2),C(0:2),B(0:2),A(2)
      COMPLEX SPGAIN
      DATA IBAND/1/,FL/1000./,FH/0./T/.0001/,L/6/,LN/2/,AMP/501*1./
      FLN=FL*T
      FHN=FH*T
      DO 5 K=1,3
        CALL SPBWCF(L,K,LN,D,C,IERROR)
        IF(IERROR.NE.0) THEN
          PRINT *,' SPBWCF ERROR = ',IERROR
          STOP
        ENDIF
        CALL SPFBLT(D,C,LN,IBAND,FLN,FHN,B,A,WORK,IERROR)
        IF(IERROR.NE.0) THEN
          PRINT *,' SPFBLT ERROR = ',IERROR
          STOP
        ENDIF
        DO 3 I=0,500
          AMP(I)=AMP(I)*ABS(SPGAIN(B,A,LN,LN,I*.5/500.))
    3   CONTINUE
        PRINT 100,K,B,A
    5 CONTINUE
      CALL PFILE2(0.,.01,AMP,501,1,'P0706A')
100   FORMAT(' SECTION ',I2,' COEFFICIENTS = ',3F8.4,5X,2F8.4)
      END
      PROGRAM SPA0707
C-DESIGN 8TH ORDER BANDPASS BUTTERWORTH FILTER.
      DIMENSION AMP(0:500),WORK(0:4,0:4),D(0:4),C(0:4),B(0:4),A(4)
      COMPLEX SPGAIN
      DATA IBAND/3/,FL/1500./,FH/3500./T/.0001/,L/8/,LN/4/,AMP/501*1./
      FLN=FL*T
      FHN=FH*T
      DO 5 K=1,2
        CALL SPBWCF(L/2,K,LN,D,C,IERROR)
        IF(IERROR.NE.0) THEN
          PRINT *,' SPBWCF ERROR = ',IERROR
          STOP
        ENDIF
        CALL SPFBLT(D,C,LN,IBAND,FLN,FHN,B,A,WORK,IERROR)
        IF(IERROR.NE.0) THEN
          PRINT *,' SPFBLT ERROR = ',IERROR
          STOP
        ENDIF
        DO 3 I=0,500
          AMP(I)=AMP(I)*ABS(SPGAIN(B,A,LN,LN,I*.5/500.))
    3   CONTINUE
        PRINT 100,K,B,A
    5 CONTINUE
      CALL PFILE2(0.,.01,AMP,501,1,'P0707A')
100   FORMAT(' SECTION ',I2,' COEFFICIENTS = ',5F9.4/27X,4F9.4)
      END
      PROGRAM SPA0708
C-DESIGN 5TH ORDER HIGHPASS BUTTERWORTH FILTER.
      DIMENSION AMP(0:500),WORK(0:2,0:2),D(0:2),C(0:2),B(0:2),A(2)
      COMPLEX SPGAIN
      DATA IBAND/2/,FL/2500./,FH/0./T/.0001/,L/5/,LN/2/,AMP/501*1./
      FLN=FL*T
      FHN=FH*T
      DO 5 K=1,3
        CALL SPBWCF(L,K,LN,D,C,IERROR)
        IF(IERROR.NE.0) THEN
          PRINT *,' SPBWCF ERROR = ',IERROR
          STOP
        ENDIF
        CALL SPFBLT(D,C,LN,IBAND,FLN,FHN,B,A,WORK,IERROR)
        IF(IERROR.NE.0) THEN
          PRINT *,' SPFBLT ERROR = ',IERROR
          STOP
        ENDIF
        DO 3 I=0,500
          AMP(I)=AMP(I)*ABS(SPGAIN(B,A,LN,LN,I*.5/500.))
    3   CONTINUE
        PRINT 100,K,B,A
    5 CONTINUE
      CALL PFILE2(0.,.01,AMP,501,1,'P0708A')
100   FORMAT(' SECTION ',I2,' COEFFICIENTS = ',3F8.4,5X,2F8.4)
      END
      PROGRAM SPA0709
C-DESIGN 6TH ORDER LOWPASS CHEBYSHEV TYPE I FILTER.
      DIMENSION AMP(0:500),WORK(0:2,0:2),D(0:2),C(0:2),B(0:2),A(2)
      COMPLEX SPGAIN
      DATA IBAND/1/,FL/1000./,FH/0./T/.0001/,L/6/,LN/2/,AMP/501*1./
      DATA EP/1./
      FLN=FL*T
      FHN=FH*T
      DO 5 K=1,3
        CALL SPCHBI(L,K,LN,EP,D,C,IERROR)
        IF(IERROR.NE.0) THEN
          PRINT *,' SPCHBI ERROR = ',IERROR
          STOP
        ENDIF
        CALL SPFBLT(D,C,LN,IBAND,FLN,FHN,B,A,WORK,IERROR)
        IF(IERROR.NE.0) THEN
          PRINT *,' SPFBLT ERROR = ',IERROR
          STOP
        ENDIF
        DO 3 I=0,500
          AMP(I)=AMP(I)*ABS(SPGAIN(B,A,LN,LN,I*.5/500.))
    3   CONTINUE
        PRINT 100,K,B,A
    5 CONTINUE
      CALL PFILE2(0.,.01,AMP,501,1,'P0709A')
100   FORMAT(' SECTION ',I2,' COEFFICIENTS = ',3F8.4,5X,2F8.4)
      END
      PROGRAM SPA0710
C-DESIGN 6TH ORDER LOWPASS CHEBYSHEV TYPE II FILTER.
      DIMENSION AMP(0:500),WORK(0:2,0:2),D(0:2),C(0:2),B(0:2),A(2)
      COMPLEX SPGAIN
      DATA IBAND/1/,FL/1000./,FH/0./T/.0001/,L/6/,LN/2/,AMP/501*1./
      DATA SB/1.57/,ATTN/15./
      FLN=FL*T
      FHN=FH*T
      DO 5 K=1,3
        CALL SPCBII(L,K,LN,SB,ATTN,D,C,IERROR)
        IF(IERROR.NE.0) THEN
          PRINT *,' SPCBII ERROR = ',IERROR
          STOP
        ENDIF
        CALL SPFBLT(D,C,LN,IBAND,FLN,FHN,B,A,WORK,IERROR)
        IF(IERROR.NE.0) THEN
          PRINT *,' SPFBLT ERROR = ',IERROR
          STOP
        ENDIF
        DO 3 I=0,500
          AMP(I)=AMP(I)*ABS(SPGAIN(B,A,LN,LN,I*.5/500.))
    3   CONTINUE
        PRINT 100,K,B,A
    5 CONTINUE
      CALL PFILE2(0.,.01,AMP,501,1,'P0710A')
100   FORMAT(' SECTION ',I2,' COEFFICIENTS = ',3F8.4,5X,2F8.4)
      END
      PROGRAM SPA0711
C-DESIGN 6TH ORDER LOWPASS BESSEL FILTER.
      DIMENSION AMP(0:500),WORK(0:6,0:6),D(0:6),C(0:6),B(0:6),A(6)
      COMPLEX SPGAIN
      DATA IBAND/1/,FL/1000./,FH/0./T/.0001/,L/6/,LN/6/,PSCL/1./
      FLN=FL*T
      FHN=FH*T
      CALL SPBSSL(L,PSCL,LN,D,C,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' SPBSSL ERROR = ',IERROR
        STOP
      ENDIF
      CALL SPFBLT(D,C,LN,IBAND,FLN,FHN,B,A,WORK,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' SPFBLT ERROR = ',IERROR
        STOP
      ENDIF
      DO 3 I=0,500
        AMP(I)=ABS(SPGAIN(B,A,LN,LN,I*.5/500.))
    3 CONTINUE
      CALL PFILE2(0.,.01,AMP,501,1,'P0711A')
      PRINT 100,B,A
100   FORMAT(' B(Z) COEF = ',7F8.4/' A(Z) COEF = ',6F8.4)
      END
      PROGRAM SPA0712
C-DESIGN 8TH ORDER BANDPASS BESSEL FILTER.
      DIMENSION AMP(0:500),WORK(0:8,0:8),D(0:8),C(0:8),B(0:8),A(8)
      COMPLEX SPGAIN
      DATA IBAND/3/,FL/1500./,FH/3500./T/.0001/,L/8/,LN/8/,PSCL/2.1/
      FLN=FL*T
      FHN=FH*T
      CALL SPBSSL(L/2,PSCL,LN,D,C,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' SPBSSL ERROR = ',IERROR
        STOP
      ENDIF
      CALL SPFBLT(D,C,LN,IBAND,FLN,FHN,B,A,WORK,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' SPFBLT ERROR = ',IERROR
        STOP
      ENDIF
      DO 3 I=0,500
        AMP(I)=ABS(SPGAIN(B,A,LN,LN,I*.5/500.))
    3 CONTINUE
      CALL PFILE2(0.,.01,AMP,501,1,'P0712A')
      PRINT 100,B,A
100   FORMAT(' B(Z) COEF = ',9F7.3/' A(Z) COEF = ',8F7.3)
      END
      PROGRAM SPA0801
C-DESIGN FIR LOWPASS FILTER USING RECTANGULAR WINDOW.
      DIMENSION B(0:20),A(1),AMP(0:500)
      COMPLEX SPGAIN
      DATA FC/200./,T/.001/,L/20/,IWNDO/1/,A/0./
      FCN=FC*T
      CALL SPFIRL(L,FCN,IWNDO,B,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' ERROR RETURNED = ',IERROR
        STOP
      ENDIF
      DO 1 I=0,500
        AMP(I)=ABS(SPGAIN(B,A,L,1,I*.5/500.))
    1 CONTINUE
      CALL PFILE2(0.,1.,AMP,501,1,'P0801A')
      PRINT 100,(N,B(N),N+7,B(N+7),N+14,B(N+14),N=0,6)
100   FORMAT(' N     B(N)        N     B(N)        N      B(N)'/
     +       (I2,F10.5,I8,F10.5,I8,F10.5))
      END
      PROGRAM SPA0802
C-DESIGN FIR LOWPASS FILTER USING TAPERED RECTANGULAR WINDOW.
      DIMENSION B(0:20),A(1),AMP(0:500)
      COMPLEX SPGAIN
      DATA FC/200./,T/.001/,L/20/,IWNDO/2/,A/0./
      FCN=FC*T
      CALL SPFIRL(L,FCN,IWNDO,B,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' ERROR RETURNED = ',IERROR
        STOP
      ENDIF
      DO 1 I=0,500
        AMP(I)=ABS(SPGAIN(B,A,L,1,I*.5/500.))
    1 CONTINUE
      CALL PFILE2(0.,1.,AMP,501,1,'P0802A')
      PRINT 100,(N,B(N),N+7,B(N+7),N+14,B(N+14),N=0,6)
100   FORMAT(' N     B(N)        N     B(N)        N      B(N)'/
     +       (I2,F10.5,I8,F10.5,I8,F10.5))
      END
      PROGRAM SPA0803
C-DESIGN FIR LOWPASS FILTER USING TRIANGULAR WINDOW.
      DIMENSION B(0:20),A(1),AMP(0:500)
      COMPLEX SPGAIN
      DATA FC/200./,T/.001/,L/20/,IWNDO/3/,A/0./
      FCN=FC*T
      CALL SPFIRL(L,FCN,IWNDO,B,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' ERROR RETURNED = ',IERROR
        STOP
      ENDIF
      DO 1 I=0,500
        AMP(I)=ABS(SPGAIN(B,A,L,1,I*.5/500.))
    1 CONTINUE
      CALL PFILE2(0.,1.,AMP,501,1,'P0803A')
      PRINT 100,(N,B(N),N+7,B(N+7),N+14,B(N+14),N=0,6)
100   FORMAT(' N     B(N)        N     B(N)        N      B(N)'/
     +       (I2,F10.5,I8,F10.5,I8,F10.5))
      END
      PROGRAM SPA0804
C-DESIGN FIR LOWPASS FILTER USING HANNING WINDOW.
      DIMENSION B(0:20),A(1),AMP(0:500)
      COMPLEX SPGAIN
      DATA FC/200./,T/.001/,L/20/,IWNDO/4/,A/0./
      FCN=FC*T
      CALL SPFIRL(L,FCN,IWNDO,B,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' ERROR RETURNED = ',IERROR
        STOP
      ENDIF
      DO 1 I=0,500
        AMP(I)=ABS(SPGAIN(B,A,L,1,I*.5/500.))
    1 CONTINUE
      CALL PFILE2(0.,1.,AMP,501,1,'P0804A')
      PRINT 100,(N,B(N),N+7,B(N+7),N+14,B(N+14),N=0,6)
100   FORMAT(' N     B(N)        N     B(N)        N      B(N)'/
     +       (I2,F10.5,I8,F10.5,I8,F10.5))
      END
      PROGRAM SPA0805
C-DESIGN FIR LOWPASS FILTER USING HAMMING WINDOW.
      DIMENSION B(0:20),A(1),AMP(0:500)
      COMPLEX SPGAIN
      DATA FC/200./,T/.001/,L/20/,IWNDO/5/,A/0./
      FCN=FC*T
      CALL SPFIRL(L,FCN,IWNDO,B,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' ERROR RETURNED = ',IERROR
        STOP
      ENDIF
      DO 1 I=0,500
        AMP(I)=ABS(SPGAIN(B,A,L,1,I*.5/500.))
    1 CONTINUE
      CALL PFILE2(0.,1.,AMP,501,1,'P0805A')
      PRINT 100,(N,B(N),N+7,B(N+7),N+14,B(N+14),N=0,6)
100   FORMAT(' N     B(N)        N     B(N)        N      B(N)'/
     +       (I2,F10.5,I8,F10.5,I8,F10.5))
      END
      PROGRAM SPA0806
C-DESIGN FIR LOWPASS FILTER USING BLACKMAN WINDOW.
      DIMENSION B(0:20),A(1),AMP(0:500)
      COMPLEX SPGAIN
      DATA FC/200./,T/.001/,L/20/,IWNDO/6/,A/0./
      FCN=FC*T
      CALL SPFIRL(L,FCN,IWNDO,B,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' ERROR RETURNED = ',IERROR
        STOP
      ENDIF
      DO 1 I=0,500
        AMP(I)=ABS(SPGAIN(B,A,L,1,I*.5/500.))
    1 CONTINUE
      CALL PFILE2(0.,1.,AMP,501,1,'P0806A')
      PRINT 100,(N,B(N),N+7,B(N+7),N+14,B(N+14),N=0,6)
100   FORMAT(' N     B(N)        N     B(N)        N      B(N)'/
     +       (I2,F10.5,I8,F10.5,I8,F10.5))
      END
      PROGRAM SPA0807
C-DESIGN FIR HIGHPASS FILTER USING RECTANGULAR WINDOW.
      DIMENSION B(0:20),A(1),AMP(0:500)
      COMPLEX SPGAIN
      DATA FL/2500./,T/.0001/,L/20/,IWNDO/1/,A/0./,IBAND/2/
      FLN=FL*T
      CALL SPFIRD(L,IBAND,FLN,0.,IWNDO,B,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' ERROR RETURNED = ',IERROR
        STOP
      ENDIF
      DO 1 I=0,500
        AMP(I)=ABS(SPGAIN(B,A,L,1,I*.5/500.))
    1 CONTINUE
      CALL PFILE2(0.,.01,AMP,501,1,'P0807A')
      PRINT 100,(N,B(N),N+7,B(N+7),N+14,B(N+14),N=0,6)
100   FORMAT(' N     B(N)        N     B(N)        N      B(N)'/
     +       (I2,F10.5,I8,F10.5,I8,F10.5))
      END
      PROGRAM SPA0808
C-DESIGN FIR BANDPASS FILTER USING HAMMING WINDOW.
      DIMENSION B(0:20),A(1),AMP(0:500)
      COMPLEX SPGAIN
      DATA FL/1500./,FH/3500./,T/.0001/,L/20/,IWNDO/5/,A/0./,IBAND/3/
      FLN=FL*T
      FHN=FH*T
      CALL SPFIRD(L,IBAND,FLN,FHN,IWNDO,B,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' ERROR RETURNED = ',IERROR
        STOP
      ENDIF
      DO 1 I=0,500
        AMP(I)=ABS(SPGAIN(B,A,L,1,I*.5/500.))
    1 CONTINUE
      CALL PFILE2(0.,1.,AMP,501,1,'P0808A')
      PRINT 100,(N,B(N),N+7,B(N+7),N+14,B(N+14),N=0,6)
100   FORMAT(' N     B(N)        N     B(N)        N      B(N)'/
     +       (I2,F10.5,I8,F10.5,I8,F10.5))
      END
      PROGRAM SPA0809
C-DESIGN FIR BANDSTOP FILTER USING HANNING WINDOW.
      DIMENSION B(0:20),A(1),AMP(0:500)
      COMPLEX SPGAIN
      DATA FL/1500./,FH/3500./,T/.0001/,L/20/,IWNDO/4/,A/0./,IBAND/4/
      FLN=FL*T
      FHN=FH*T
      CALL SPFIRD(L,IBAND,FLN,FHN,IWNDO,B,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' ERROR RETURNED = ',IERROR
        STOP
      ENDIF
      DO 1 I=0,500
        AMP(I)=ABS(SPGAIN(B,A,L,1,I*.5/500.))
    1 CONTINUE
      CALL PFILE2(0.,1.,AMP,501,1,'P0809A')
      PRINT 100,(N,B(N),N+7,B(N+7),N+14,B(N+14),N=0,6)
100   FORMAT(' N     B(N)        N     B(N)        N      B(N)'/
     +       (I2,F10.5,I8,F10.5,I8,F10.5))
      END
      PROGRAM SPA0901
C-SIMPLE EXAMPLE OF AUTOCORRELATION.
      DIMENSION X(0:9)
      DATA X/0.,1.,2.,-1.,0.,0.,0.,0.,0.,0./
      CALL SPCORR(X,X,9,0,5,IERR)
      PRINT 1,IERR,(K,X(K),K=0,5)
    1 FORMAT(I2/(I3,F6.1))
      STOP
      END
      PROGRAM SPA0902
C-SIMPLE EXAMPLE OF CROSS CORRELATION.
      DIMENSION X(0:9),Y(0:9)
      DATA X/0.,1.,2.,-1.,0.,0.,0.,0.,0.,0./
      DATA Y/1.,-1.,1.,-1.,0.,0.,0.,0.,0.,0./
      CALL SPCORR(X,Y,9,1,4,IERR)
      PRINT 1,IERR,(K,X(K),K=0,4)
    1 FORMAT(I2/(I3,F6.1))
      STOP
      END
      PROGRAM SPA0903
C-AUTOCORRELATION OF 1500 SAMPLES OF A SINE WAVE IN NOISE.
      DIMENSION X(0:2049)
      PI=4.*ATAN(1.)
      ISEED=100
      DO 1 K=0,1499
        X(K)=SIN(2.*PI*K/25.)+SQRT(12.*5.)*(SPRAND(ISEED)-.5)
    1 CONTINUE
      CALL PFILE2(0.,1.,X,301,1,'P0903A')
      DO 2 K=1500,2047
        X(K)=0.
    2 CONTINUE
      CALL SPCORR(X,X,2049,0,300,IERR)
      IF(IERR.NE.0) PAUSE
      CALL PFILE2(0.,1.,X,301,1,'P0903B')
      STOP
      END
      PROGRAM SPA0904
C-SIMPLE EXAMPLE OF CONVOLUTION.
      DIMENSION X(0:9),Y(0:9)
      DATA X/0.,1.,2.,-1.,0.,0.,0.,0.,0.,0./
      DATA Y/1.,-1.,1.,-1.,0.,0.,0.,0.,0.,0./
      CALL SPCONV(X,Y,9,0,IERR)
      IF(IERR.NE.0) PAUSE
      PRINT 1,(K,X(K),K=0,7)
    1 FORMAT(I3,F6.1)
      STOP
      END
      PROGRAM SPA0905
C-MORE OR LESS REALISTIC EXAMPLE OF CONVOLUTION.
      DIMENSION X(0:2049),Y(0:2049),COEFF(0:7)
      DATA COEFF/8.,4.,7.,2.,6.,3.,1.,1./
      PI=4.*ATAN(1.)
      DO 1 K=0,2047
        X(K)=EXP(-K/50.)*SIN(2.*PI*K/50.)
        IF(K.GT.400) X(K)=0.
        Y(K)=0.
        IF(K.LE.700.AND.MOD(K,100).EQ.0) Y(K)=COEFF(K/100)
    1 CONTINUE
      CALL PFILE2(0.,1.,X,1000,1,'P0905A')
      CALL PFILE2(0.,1.,Y,1000,1,'P0905B')
      CALL SPCONV(X,Y,2049,0,IERR)
      IF(IERR.NE.0) PAUSE
      CALL PFILE2(0.,1.,X,1000,1,'P0905C')
      STOP
      END
      PROGRAM SPA1001
C-TWO SIMPLE EXAMPLES OF DECIMATION.
      DIMENSION DATA(0:9),X(0:9)
      DATA DATA/0.,2.,4.,6.,8.,8.,6.,4.,2.,0./
      DO 1 K=0,9
        X(K)=DATA(K)
    1 CONTINUE
      CALL SPDECI(X,9,2.0,LX2,IERROR)
      PRINT 2,IERROR,LX2,X
    2 FORMAT(2I2,4X,10F6.2)
      DO 3 K=0,9
        X(K)=DATA(K)
    3 CONTINUE
      CALL SPDECI(X,9,1.5,LX2,IERROR)
      PRINT 2,IERROR,LX2,X
      STOP
      END
      PROGRAM SPA1002
C-TWO SIMPLE EXAMPLES OF LINEAR INTERPOLATION.
      DIMENSION DATA(0:10),X(0:10)
      DATA DATA/2.,4.,6.,6.,8.,6.,0.,0.,0.,0.,0./
      DO 1 K=0,10
        X(K)=DATA(K)
    1 CONTINUE
      CALL SPLINT(X,10,5,0.5,LX2,IERROR)
      PRINT 2,IERROR,LX2,X
    2 FORMAT(I2,I3,3X,11F5.1)
      DO 3 K=0,10
        X(K)=DATA(K)
    3 CONTINUE
      CALL SPLINT(X,10,5,0.75,LX2,IERROR)
      PRINT 2,IERROR,LX2,X
      STOP
      END
      PROGRAM SPA1003
C-SIMPLE EXAMPLE OF INTERPOLATION USING SPZINT.
      DIMENSION X(0:17)
      DATA X/2.,4.,6.,6.,8.,6.,12*0./
      CALL SPZINT(X,17,6,0.5,LX2,IERROR)
      PRINT 1,IERROR,LX2,(X(K),K=0,LX2)
    1 FORMAT(2I4/(10F7.3))
      STOP
      END
      PROGRAM SPA1004
C-MORE INTERESTING EXAMPLE OF INTERPOLATION USING SPZINT.
C-RESULTS ARE PLOTTED IN FIGURE 10.13.
      DIMENSION X(0:257)
      PI=4.*ATAN(1.)
      DO 1 K=0,15
        X(K)=SIN(2.*PI*K/4.+0.5)
    1 CONTINUE
      CALL SPZINT(X,257,15,1./16.,LX2,IERROR)
      PRINT 2,IERROR,LX2
    2 FORMAT(' IERROR,LX2=',2I4)
      STOP
      END
      PROGRAM SPA1005
C-SIMPLE EXAMPLE OF INTERPOLATION WITH TIME-STEP RATIO=I/J=3/4.
      DIMENSION X(0:33)
      DATA X/2.,4.,6.,6.,8.,6.,28*0./
      CALL SPZINT(X,33,6,1./4.,LX2,IERROR)
      PRINT 1,IERROR,LX2,(X(K),K=0,LX2)
    1 FORMAT(2I4,/(10F7.3))
      CALL SPDECI(X,LX2,3.0,LX3,IERROR)
      PRINT1,IERROR,LX3,(X(K),K=0,LX3)
      STOP
      END
      PROGRAM SPA1006
C-SPECTRA OF ORIGINAL (S1) AND INTERPOLATED (S2) SINUSOIDS.
      DIMENSION X(0:513),S1(0:17),S2(0:241)
      PI=4.*ATAN(1.)
      DO 1 K=0,15
        X(K)=SIN(2.*PI*K/4.+0.5)
    1 CONTINUE
      CALL SPDFTR(X,S1,16)
      DO 2 M=0,8
        S1(M)=SQRT(S1(2*M)**2+S1(2*M+1)**2)/8.0
    2 CONTINUE
      CALL SPZINT(X,513,15,1./16.,LX2,IERROR1)
      CALL SPLINT(X,513,LX2,0.05*16,LX3,IERROR2)
      PRINT 3,IERROR1,IERROR2,LX2,LX3
    3 FORMAT('IERROR1,IERROR2,LX2,LX3:',4I5/)
      CALL SPDFTR(X,S2,240)
      DO 4 M=0,120
        S2(M)=SQRT(S2(2*M)**2+S2(2*M+1)**2)/120.0
    4 CONTINUE
      PRINT 5,(M,S1(M),S2(M),M=0,8)
    5 FORMAT('  M SPECTRUM 1 SPECTRUM 2'/(I3,2F11.7))
      STOP
      END
      PROGRAM SPA1101
C-DEMONSTRATE THE USE OF SPNORM.
      DIMENSION X(0:50),Y(0:50),A(0:3,0:3),C(0:3)
      DATA N/51/,L/3/
      DO 1 K=0,N-1
        X(K)=K/50.
        Y(K)=10.*(X(K)**3)-3.*(X(K)**2)-5.*X(K)-1.
    1 CONTINUE
      CALL SPNORM(X,Y,N,L,A,C,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPNORM ERROR = ',IERROR
      PRINT 100,((A(I,J),J=0,3),C(I),I=0,3)
100   FORMAT(19X,'A-MATRIX',24X,'C'/(4F10.2,5X,F10.2))
      END
      PROGRAM SPA1102
C-DEMONSTRATE THE USE OF SPSOLV.
      DIMENSION X(0:50),Y(0:50),A(0:3,0:3),B(0:3),C(0:3)
      DATA N/51/,L/3/
      DO 1 K=0,N-1
        X(K)=K/50.
        Y(K)=10.*(X(K)**3)-3.*(X(K)**2)-5.*X(K)-1.
    1 CONTINUE
      CALL SPNORM(X,Y,N,L,A,C,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPNORM ERROR = ',IERROR
      CALL SPSOLV(A,C,L,B,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPSOLV ERROR = ',IERROR
      PRINT 100,(I,B(I),I=0,3)
100   FORMAT(' POLYNOMIAL COEFFICIENTS'/(' B(',I1,') = ',F7.2))
      END
      PROGRAM SPA1103
C-DEMONSTRATE LEAST-SQUARES DATA FITTING VIA SPNORM AND SPSOLV.
      DIMENSION X(0:50),Y(0:50),A(0:5,0:5),B(0:5),C(0:5),POLY(0:500)
      DATA N/51/,L/5/,ISEED/12357/
      DO 1 K=0,N-1
        X(K)=K/50.
        Y(K)=10.*(X(K)**3)-3.*(X(K)**2)-5.*X(K)-1.
     +          +.4*(SPRAND(ISEED)-.5)
    1 CONTINUE
      CALL SPNORM(X,Y,N,L,A,C,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPNORM ERROR = ',IERROR
      CALL SPSOLV(A,C,L,B,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPSOLV ERROR = ',IERROR
      DO 2 K=0,500
        PX=K/500.
        POLY(K)=B(0)+B(1)*PX+B(2)*(PX**2)+B(3)*(PX**3)+B(4)*(PX**4)+
     +               B(5)*(PX**5)
    2 CONTINUE
      CALL PFILE2(0.,.02,Y,51,1,'P1103A')
      CALL PFILE2(0.,.002,POLY,501,1,'P1103B')
      PRINT 100,(I,B(I),I=0,5)
100   FORMAT(' POLYNOMIAL COEFFICIENTS'/(' B(',I1,') = ',F7.2))
      END
      PROGRAM SPA1104
C-DEMONSTRATE DATA FITTING VIA ORTHOGONAL POLYNOMIALS.
      DIMENSION Y(0:50),WORK(0:3,0:3),ORTHB(0:3),B(0:3)
      DATA N/51/,L/3/,DX/.02/
      DO 1 K=0,N-1
        PX=K/50.
        Y(K)=10.*(PX**3)-3.*(PX**2)-5.*PX-1.
    1 CONTINUE
      CALL SPPOLY(DX,Y,N,L,B,ORTHB,WORK,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPPOLY ERROR = ',IERROR
      PRINT 100,(I,ORTHB(I),I,B(I),I=0,3)
100   FORMAT(10X,' POLYNOMIAL COEFFICIENTS'/(' ORTHB(',I1,') =',
     +       F8.2,10X,'B(',I1,') =',F8.2))
      END
      PROGRAM SPA1105
C-DEMONSTRATE LEAST-SQUARES DATA FITTING VIA ORTHOGONAL POLYNOMIALS.
      DIMENSION Y(0:50),WORK(0:5,0:5),ORTHB(0:5),B(0:5),PY(0:500)
      DATA N/51/,L/5/,DX/.02/,ISEED/12357/
      DO 1 K=0,N-1
        PX=K/50.
        Y(K)=10.*(PX**3)-3.*(PX**2)-5.*PX-1. + .4*(SPRAND(ISEED)-.5)
    1 CONTINUE
      CALL SPPOLY(DX,Y,N,L,B,ORTHB,WORK,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPPOLY ERROR = ',IERROR
      DO 2 K=0,500
        PX=K/500.
        PY(K)=B(0)+B(1)*PX+B(2)*(PX**2)+B(3)*(PX**3)+B(4)*(PX**4)+
     +               B(5)*(PX**5)
    2 CONTINUE
      CALL PFILE2(0.,.02,Y,51,1,'P1105A')
      CALL PFILE2(0.,.002,PY,501,1,'P1105B')
      PRINT 100,(I,ORTHB(I),I,B(I),I=0,5)
100   FORMAT(10X,' POLYNOMIAL COEFFICIENTS'/(' ORTHB(',I1,') =',
     +       F8.2,10X,'B(',I1,') =',F8.2))
      END
      PROGRAM SPA1106
C-DEMONSTRATE LEAST-SQUARES DATA FITTING VIA ORTHOGONAL POLYNOMIALS.
      DIMENSION Y(0:50),WORK(0:3,0:3),ORTHB(0:3),B(0:3),PY(0:500)
      DATA N/51/,L/3/,DX/.02/,ISEED/12357/
      DO 1 K=0,N-1
        PX=K/50.
        Y(K)=10.*(PX**3)-3.*(PX**2)-5.*PX-1. + .4*(SPRAND(ISEED)-.5)
    1 CONTINUE
      CALL SPPOLY(DX,Y,N,L,B,ORTHB,WORK,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPPOLY ERROR = ',IERROR
      DO 2 K=0,500
        PX=K/500.
        PY(K)=B(0)+B(1)*PX+B(2)*(PX**2)+B(3)*(PX**3)
    2 CONTINUE
      CALL PFILE2(0.,.02,Y,51,1,'P1106A')
      CALL PFILE2(0.,.002,PY,501,1,'P1106B')
      PRINT 100,(I,ORTHB(I),I,B(I),I=0,3)
100   FORMAT(10X,' POLYNOMIAL COEFFICIENTS'/(' ORTHB(',I1,') =',
     +       F8.2,10X,'B(',I1,') =',F8.2))
      END
      PROGRAM SPA1107
C-DEMONSTRATE THE USE OF LEVINSON'S ALGORITHM.
      DIMENSION AVECT(0:1),C(0:1),B(0:1),WK(0:1)
      DIMENSION X(0:50),Y(0:50),PX(0:1)
      DATA AVECT/2.,1.618/,C/0.,-2.351/,L/1/,PY/0/,PX/2*0./,A/0./
      PI=4.*ATAN(1.)
      CALL SPLEVS(AVECT,C,L,B,WK,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPLEVS ERROR = ',IERROR
      DO 1 K=0,50
        X(K)=2.*SIN(2.*PI*K/10.)
        Y(K)=4.*COS(2.*PI*K/10.)
    1 CONTINUE
      CALL SPFILT(B,A,L,1,X,51,PX,PY,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPFILT ERROR = ',IERROR
      CALL PFILE2(0.,1.,Y,51,1,'P1107A')
      CALL PFILE2(0.,1.,X,51,1,'P1107B')
      PRINT 100,(I,B(I),I=0,1)
100   FORMAT(' FILTER COEFFICIENTS'/(' B(',I1,') =',F10.3))
      END
      PROGRAM SPA1108
C-DEMONSTRATE THE USE OF LEVINSON'S ALGORITHM.
      DIMENSION AVECT(0:6),C(0:6),B(0:6),WK(0:6)
      DATA L/6/
      PI=4.*ATAN(1.)
      DO 1 LL=0,L
        AVECT(LL)=2.*COS(2.*PI*LL/10.)
        C(LL)=-4.*SIN(2.*PI*LL/10.)
    1 CONTINUE
      CALL SPLEVS(AVECT,C,L,B,WK,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPLEVS ERROR = ',IERROR
      PRINT 100,(I,B(I),I=0,L)
100   FORMAT(' FILTER COEFFICIENTS'/(' B(',I1,') =',F10.3))
      END
      PROGRAM SPA1109
C-DEMONSTRATE THE USE OF LEVINSON'S ALGORITHM.
      DIMENSION AVECT(0:6),C(0:6),B(0:6),WK(0:6)
      DIMENSION X(0:50),Y(0:50),PX(0:6)
      DATA L/6/,PY/0/,PX/7*0./,A/0./
      PI=4.*ATAN(1.)
      DO 1 LL=0,L
        AVECT(LL)=2.*COS(2.*PI*LL/10.)
        C(LL)=-4.*SIN(2.*PI*LL/10.)
    1 CONTINUE
      AVECT(0)=1.001*AVECT(0)
      CALL SPLEVS(AVECT,C,L,B,WK,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPLEVS ERROR = ',IERROR
      DO 2 K=0,50
        X(K)=2.*SIN(2.*PI*K/10.)
        Y(K)=4.*COS(2.*PI*K/10.)
    2 CONTINUE
      CALL SPFILT(B,A,L,1,X,51,PX,PY,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPFILT ERROR = ',IERROR
      CALL PFILE2(0.,1.,Y,51,1,'P1109A')
      CALL PFILE2(0.,1.,X,51,1,'P1109B')
      PRINT 100,(I,B(I),I=0,L)
100   FORMAT(' FILTER COEFFICIENTS'/(' B(',I1,') =',F10.3))
      END
      PROGRAM SPA1110
C-DEMONSTRATE THE USE OF DURBIN'S ALGORITHM.
      DIMENSION AAVECT(0:2),B(0:1),X(0:50),Y(0:50),PX(0:1)
      DATA L/1/,PX/2*0./,A/0./,PY/0./
      PI=4.*ATAN(1.)
      DO 1 LL=0,L+1
        AAVECT(LL)=.5*COS(2.*PI*LL/10.)
    1 CONTINUE
      CALL SPDURB(AAVECT,L,B,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' SPDURB ERROR = ',IERROR
        PAUSE
      ENDIF
      DO 2 K=0,50
        X(K)=SIN(2.*PI*K/10.)
        Y(K)=COS(2.*PI*(K-1)/10.)
    2 CONTINUE
      CALL SPFILT(B,A,L,1,X,51,PX,PY,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPFILT ERROR = ',IERROR
      CALL PFILE2(0.,1.,Y,51,1,'P1110A')
      CALL PFILE2(0.,1.,X,51,1,'P1110B')
      PRINT 100,(I,B(I),I=0,L)
100   FORMAT(' FILTER COEFFICIENTS'/(' B(',I1,') =',F10.3))
      END
      PROGRAM SPA1111
C-DEMONSTRATE THE USE OF DURBIN'S ALGORITHM.
      DIMENSION AAVECT(0:7),B(0:6)
      DATA L/6/
      PI=4.*ATAN(1.)
      DO 1 LL=0,L+1
        AAVECT(LL)=.5*COS(2.*PI*LL/10.)
    1 CONTINUE
      CALL SPDURB(AAVECT,L,B,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPDURB ERROR = ',IERROR
      PRINT 100,(I,B(I),I=0,L)
100   FORMAT(' FILTER COEFFICIENTS'/(' B(',I2,') =',F10.3))
      END
      PROGRAM SPA1201
C-DEMONSTRATE THE USE OF LMS ALGORITHM FOR LINE ENHANCEMENT.
      DIMENSION X(0:500),D(0:500),B(0:20),PX(0:20)
      REAL MU
      DATA N/501/,MU/.1/,ISEED/12357/,B/21*0./,PX/21*0./
      DATA X(0)/0./,L/20/,SIG/2./,AL/0./
      PI=4.*ATAN(1.)
      DO 1 K=0,N-2
        D(K)=SQRT(2.)*SIN(2.*PI*K/20.)+SQRT(12.)*(SPRAND(ISEED)-.5)
        X(K+1)=D(K)
    1 CONTINUE
      D(500)=SQRT(2.)*SIN(2.*PI*500./20.)+SQRT(12.)*(SPRAND(ISEED)-.5)
      CALL SPNLMS(X,N,D,B,L,MU,SIG,AL,PX,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' SPNLMS ERROR = ',IERROR
        STOP
      ENDIF
      CALL PFILE2(0.,1.,X,N,1,'P1201A')
      CALL PFILE2(0.,1.,D,N,1,'P1201B')
      END
      PROGRAM SPA1202
C-DEMONSTRATE THE USE OF NLMS ALGORITHM FOR LINE ENHANCEMENT.
      DIMENSION X(0:500),D(0:500),B(0:20),PX(0:20),A(1)
      COMPLEX SPGAIN
      REAL MU
      DATA N/501/,MU/.01/,ISEED/12357/,B/21*0./,PX/21*0./
      DATA X(0)/0./,L/20/,SIG/2./,AL/.01/,A(1)/0./
      PI=4.*ATAN(1.)
      DO 1 K=0,N-2
        D(K)=SQRT(2.)*SIN(2.*PI*K/20.)+SQRT(12.)*(SPRAND(ISEED)-.5)
        X(K+1)=D(K)
    1 CONTINUE
      D(500)=SQRT(2.)*SIN(2.*PI*500./20.)+SQRT(12.)*(SPRAND(ISEED)-.5)
      CALL SPNLMS(X,N,D,B,L,MU,SIG,AL,PX,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' SPNLMS ERROR = ',IERROR
        STOP
      ENDIF
      CALL PFILE2(0.,1.,X,N,1,'P1202A')
      DO 2 K=0,500
        X(K)=ABS(SPGAIN(B,A,L,1,K*.5/500.))
    2 CONTINUE
      CALL PFILE2(0.,.001,X,N,1,'P1202B')
      END
      PROGRAM SPA1203
C-ADAPTIVE INTERFERENCE CANCELLING
      DIMENSION X(0:500),D(0:500),B(0:4),PX(0:4),SI(0:500)
      REAL MU
      DATA B/5*0./,PX/5*0./,ISEED/12357/
      DATA L/4/,N/501/,MU/.1/,SIG/.005/,AL/0./
      PI=4.*ATAN(1.)
      DO 1 K=0,N-1
        F=2.*PI*K/20.
        SI(K)=(1.+.01*K)*SIN(F+PI/3.)
        D(K)=SQRT(12.)*(SPRAND(ISEED)-.5)+SI(K)
        X(K)=.1*SIN(F)
    1 CONTINUE
      CALL PFILE2(0.,1.,SI,251,1,'P1203A')
      CALL PFILE2(0.,1.,X,251,1,'P1203B')
      CALL SPNLMS(X,N,D,B,L,MU,SIG,AL,PX,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' SPNLMS ERROR = ',IERROR
        STOP
      ENDIF
      CALL PFILE2(0.,1.,X,251,1,'P1203C')
      CALL PFILE2(250.,1.,SI(250),251,1,'P1203D')
      CALL PFILE2(250.,1.,X(250),251,1,'P1203E')
      CALL PFILE2(0.,1.,D,251,1,'P1203F')
      END
      PROGRAM SPA1204
C-ADAPTIVE SYSTEM IDENTIFICATION
      DIMENSION X(0:1000),D(0:1000),B(0:30),PX(0:30)
      DIMENSION SB(0:20),SA(1),SPX(0:20),SPY(1)
      REAL MU
      DATA N/1001/,L/30/,MU/.1/,SIG/1./,AL/0./
      DATA B/31*0./,PX/31*0./,SA/0./,SPX/21*0./,ISEED/12357/
      DO 1 K=0,N-1
        X(K)=SQRT(12.)*(SPRAND(ISEED)-.5)
    1 CONTINUE
      CALL SPFIRD(20,3,.15,.35,1,SB,IERROR)
      IF(IERROR.NE.0) STOP ' SPFIRD ERROR'
      CALL SPFLTR(SB,SA,20,1,X,N,D,SPX,SPY,IERROR)
      IF(IERROR.NE.0) STOP ' SPFLTR ERROR'
      CALL SPNLMS(X,N,D,B,L,MU,SIG,AL,PX,IERROR)
      IF(IERROR.NE.0) STOP ' SPNLMS ERROR'
      DO 2 K=0,N-1
        D(K)=(D(K)-X(K))**2
    2 CONTINUE
      CALL PFILE2(0.,1.,D,N,1,'P1204A')
      CALL PFILE2(0.,1.,B,31,1,'P1204B')
      CALL PFILE2(0.,1.,SB,21,1,'P1204C')
      END
      PROGRAM SPA1205
C-ADAPTIVE DESIGN OF A FILTER
      DIMENSION X(0:500),D(0:500),B(0:50),PX(0:50),A(1),AMP(0:40)
      COMPLEX SPGAIN
      REAL MU
      DATA N/501/,L/50/,MU/.2/,SIG/.2/,AL/0./
      DATA B/51*0./,PX/51*0./,A/0./,AMP/20*1.,.5,20*0./
      PI=4.*ATAN(1.)
      DO 2 K=0,N-1
        D(K)=.1*AMP(0)
        X(K)=.1
        DO 1 J=1,40
          D(K)=D(K)+AMP(J)*.1*SIN(2.*PI*.0125*J*(K-L/2))
          X(K)=X(K)+.1*SIN(2.*PI*.0125*J*K)
    1   CONTINUE
    2 CONTINUE
      CALL SPNLMS(X,N,D,B,L,MU,SIG,AL,PX,IERROR)
      IF(IERROR.NE.0) STOP ' SPNLMS ERROR'
      DO 3 K=0,N-1
        X(K)=ABS(SPGAIN(B,A,L,1,K*.5/500.))
    3 CONTINUE
      CALL PFILE2(0.,.001,X,N,1,'P1205A')
      CALL PFILE2(0.,.0125,AMP,41,1,'P1205B')
      CALL PFILE2(0.,1.,B,51,1,'P1205C')
      END
      PROGRAM SP1301
C-COMPUTE MEAN AND VARIANCE OF VECTOR OF RANDOM NUMBERS
      DIMENSION X(0:99999),LEN(5)
      DATA LEN/10,100,1000,10000,100000/,ISEED/12357/
      DO 1 K=0,99999
        X(K)=SPRAND(ISEED)
    1 CONTINUE
      PRINT 100
      DO 2 L=1,5
        AVG=SPMEAN(X,LEN(L))
        VAR=SPVARI(X,LEN(L))
        PRINT 200,LEN(L),AVG,VAR
    2 CONTINUE
100   FORMAT(' LENGTH',10X,'MEAN',13X,'VARIANCE')
200   FORMAT(I7,7X,F10.7,7X,F10.7)
      END
      PROGRAM SPA1302
C-DEMONSTRATE USE OF STRAIGHT LINE FIT ROUTINE.
      DIMENSION X(0:50),Y(0:50),PLT(2)
      DATA A/.05/,B/.25/,ISEED/12357/,N/51/
      DO 1 K=0,50
        X(K)=K
        Y(K)=A*X(K)+B + .25*(SPRAND(ISEED)-.5)
    1 CONTINUE
      CALL SPLFIT(X,Y,N,AEST,BEST,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' SPLFIT ERROR = ',IERROR
        STOP
      ENDIF
      CALL PFILE2(0.,1.,Y,51,1,'P1302A')
      PLT(1)=BEST
      PLT(2)=AEST*50.+BEST
      CALL PFILE2(0.,50.,PLT,2,1,'P1302B')
      PRINT 100,AEST,BEST
100   FORMAT(' EQUATION:  Y = ',F5.3,'X + 'F5.3)
      END
      PROGRAM SPA1303
C-DEMONSTRATE USE OF EXPONENTIAL FIT ROUTINE.
      DIMENSION X(0:50),Y(0:50),PLT(0:500)
      DATA A/2./,B/.95/,ISEED/12357/,N/51/
      DO 1 I=0,50
        X(I)=I
        Y(I)=A*(B**I) + .2*(SPRAND(ISEED)-.5)
    1 CONTINUE
      CALL PFILE2(0.,1.,Y,N,1,'P1303A')
      CALL SPEXPN(X,Y,N,AEST,BEST,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' SPEXPN ERROR = ',IERROR
        STOP
      ENDIF
      DO 2 I=0,500
        PLT(I)=AEST*(BEST**(I/10.))
    2 CONTINUE
      CALL PFILE2(0.,.1,PLT,501,1,'P1303B')
      PRINT 100,AEST,BEST
100   FORMAT(' EQUATION:  Y = (',F4.2,')(',F5.3,'**X)')
      END
      PROGRAM SPA1304
C-DEMONSTRATE USE OF POWER FUNCTION FIT ROUTINE.
      DIMENSION X(0:50),Y(0:50),PLT(0:500)
      DATA A/.5/,B/.5/,ISEED/12357/,N/51/
      DO 1 I=0,50
        X(I)=I+1
        Y(I)=A*(X(I)**B) + .25*(SPRAND(ISEED)-.5)
    1 CONTINUE
      CALL PFILE2(0.,1.,Y,N,1,'P1304A')
      CALL SPPWRC(X,Y,N,AEST,BEST,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' SPPWRC ERROR = ',IERROR
        STOP
      ENDIF
      DO 2 I=0,500
        PLT(I)=AEST*((I/10.+1.)**BEST)
    2 CONTINUE
      CALL PFILE2(0.,.1,PLT,501,1,'P1304B')
      PRINT 100,AEST,BEST
100   FORMAT(' EQUATION:  Y = ',F4.2,'*(X**',F4.2,')')
      END
      PROGRAM SPA1305
C-DEMONSTRATE USE OF SPXEXP ROUTINE.
      DIMENSION X(0:50),Y(0:50),PLT(0:500)
      DATA A/-.1/,B/.5/,ISEED/12357/,N/51/
      DO 1 I=0,50
        X(I)=I+1.
        Y(I)=B*X(I)*EXP(A*X(I)) + .2*(SPRAND(ISEED)-.5)
    1 CONTINUE
      CALL PFILE2(0.,1.,Y,N,1,'P1305A')
      CALL SPXEXP(X,Y,N,AEST,BEST,IERROR)
      IF(IERROR.NE.0) THEN
        PRINT *,' SPXEXP ERROR = ',IERROR
        STOP
      ENDIF
      DO 2 I=0,500
        PLT(I)=BEST*(I/10.+1.)*EXP(AEST*(I/10.+1.))
    2 CONTINUE
      CALL PFILE2(0.,.1,PLT,501,1,'P1305B')
      PRINT 100,BEST,AEST
100   FORMAT(' EQUATION:  Y = ',F4.2,'*X*EXP(',F4.2,'*X)')
      END
      PROGRAM SPA1306
C-DEMONSTRATE USE OF SPLMTS ROUTINE.
      DIMENSION X(0:100)
      DATA N/101/
      PI=4.*ATAN(1.)
      DO 1 I=0,49
        X(I)=SIN(2.*PI*.25*(I-50))/(PI*(I-50))
        X(100-I)=X(I)
    1 CONTINUE
      X(50)=.5
      CALL SPLMTS(X,N,XMIN,IMIN,XMAX,IMAX)
      CALL PFILE2(0.,1.,X,N,1,'P1306A')
      PRINT 100,IMAX,XMAX,IMIN,XMIN
100   FORMAT(' MAXIMUM VALUE:  X(',I3,') = ',F5.3/
     +       ' MINIMUM VALUE:  X(',I3,') = ',F5.3)
      END
      PROGRAM SPA1307
C-DEMONSTRATE USE OF SPRFTM ROUTINE.
      DIMENSION X(0:50)
      DATA N/51/
      DO 1 I=0,50
        X(I)=I*EXP(-.1*I)
    1 CONTINUE
      CALL SPRFTM(1,X,N,R0,R10,R90,R100,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPRFTM ERROR = ',IERROR
      CALL SPRFTM(-1,X,N,F0,F10,F90,F100,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPRFTM ERROR = ',IERROR
      CALL PFILE2(0.,1.,X,N,1,'P1307A')
      PRINT 100
      PRINT 200,R0,R10,R90,R100
      PRINT 300,F0,F10,F90,F100
100   FORMAT(16X,'MIN',7X,'10%',7X,'90%',7X,'MAX')
200   FORMAT(' RISE TIME',4(4X,F6.2))
300   FORMAT(' FALL TIME',4(4X,F6.2))
      END
      PROGRAM SPA1308
C-DEMONSTRATE USE OF SPRFTM ROUTINE.
      DIMENSION X(0:50)
      DATA N/51/
      PI=4.*ATAN(1.)
      DO 1 I=0,24
        X(I)=SIN(2.*PI*.25*(I-25))/(PI*(I-25))
        X(50-I)=X(I)
    1 CONTINUE
      X(25)=.5
      CALL SPRFTM(1,X,N,R0,R10,R90,R100,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPRFTM ERROR = ',IERROR
      CALL SPRFTM(-1,X,N,F0,F10,F90,F100,IERROR)
      IF(IERROR.NE.0) PRINT *,' SPRFTM ERROR = ',IERROR
      CALL PFILE2(0.,1.,X,N,1,'P1308A')
      PRINT 100
      PRINT 200,R0,R10,R90,R100
      PRINT 300,F0,F10,F90,F100
100   FORMAT(16X,'MIN',7X,'10%',7X,'90%',7X,'MAX')
200   FORMAT(' RISE TIME',4(4X,F6.2))
300   FORMAT(' FALL TIME',4(4X,F6.2))
      END
      PROGRAM SPA1401
C-PLOTS OF SIX DATA WINDOWS.
      DIMENSION X(0:255),W(0:255,6),TSV(6)
      DO 2 I=6,1,-1
        DO 1 K=0,255
          X(K)=K
          W(K,I)=1.
    1   CONTINUE
        CALL SPMASK(W(0,I),255,I,TSV(I),IE)
        IF(IE.NE.0) STOP
    2 CONTINUE
      CALL PFILE1(X,W,256,6,'P1401A')
      PRINT 3,(I,TSV(I),I=1,6)
    3 FORMAT(' TYPE   TSV'/(I4,F12.6))
      STOP
      END
      PROGRAM SPA1402
C-POWER DENSITY SPECTRA USING 6 DIFFERENT DATA WINDOWS.
      DIMENSION X(-2:999),Y(0:16,6),WK(0:33)
C-GENERATE THE TIME SERIES.
      ISEED=321
      X(-1)=0.
      X(-2)=0.
      DO 1 K=0,999
        X(K)=SQRT(12.)*(SPRAND(ISEED)-.5)+X(K-1)-.8*X(K-2)
    1 CONTINUE
C-COMPUTE AND PLOT THE 6 POWER SPECTRA.
      DO 3 IWINDO=6,1,-1
        CALL SPPOWR(X(0),Y(0,IWINDO),WK,999,16,IWINDO,.5,NS,IE)
        IF(IE.NE.0) STOP
        DO 2 M=0,16
          Y(M,IWINDO)=10.*ALOG10(Y(M,IWINDO))
    2   CONTINUE
    3 CONTINUE
      CALL PFILE2(0.,1./32.,Y,17,6,'P1402A')
      STOP
      END
      PROGRAM SPA1403
C-PHASE RESPONSE OF FIR FILTER, H(Z)=1-4*Z**(-1)+4*Z**(-2).
      DIMENSION FREQ(0:200),PHASE(0:200),B(0:2)
      COMPLEX G,SPGAIN
      DATA B/1.,-4.,4./
      PI=4.*ATAN(1.)
      DO 1 M=0,200
        FREQ(M)=0.5*M/200.
        G=SPGAIN(B,0.,2,1,FREQ(M))
        PHASE(M)=ATAN2(AIMAG(G),REAL(G))*180./PI
    1 CONTINUE
      CALL PFILE1(FREQ,PHASE,201,1,'P1403A')
      CALL SPUNWR(PHASE,200,2)
      CALL PFILE1(FREQ,PHASE,201,1,'P1403B')
      STOP
      END
      PROGRAM SPA1404
C-HILBERT TRANSFORM OF A SINE WAVE WITH 30 SAMPLES/PERIOD.
      DIMENSION T(0:150),X(0:150),XD(0:150),Y(0:150)
      DIMENSION B(0:64),PX(0:64)
      DATA PX/65*0./
      PI=4.*ATAN(1.)
C-GENERATE THE SINE WAVE PLUS A VERSION DELAYED BY 32 SAMPLES.
      DO 1 K=0,150
        T(K)=K
        X(K)=SIN(2.*PI*K/30.)
        XD(K)=SIN(2.*PI*(K-32)/30.)
    1 CONTINUE
C-GENERATE THE HILBERT-TRANSFORMED VERSION USING L=65 WEIGHTS.
      CALL SPHILB(B,64)
      CALL SPFLTR(B,0.,64,1,X,151,Y,PX,PX,IE)
      IF(IE.NE.0) PAUSE 1
C-PLOT THE DELAYED AND TRANSFORMED WAVEFORMS.
      CALL PFILE1(T,XD,151,1,'P1404A')
      CALL PFILE1(T,Y, 151,1,'P1404B')
      STOP
      END
      PROGRAM SPA1405
C-USES THE CHIRP Z-TRANSFORM TO FIND THE SPECTRUM OF 
C-EXP(-K/176)*SIN(2*PI*K/160) FROM 0.0 TO 0.03 HZ-S.
      DIMENSION FREQ(0:1124),AMPL(0:1124)
      COMPLEX X(0:2047),WORK(0:2047)
      PI=4.*ATAN(1.)
C-GENERATE THE TIME SERIES.
      DO 1 K=0,923
        X(K)=EXP(-K/176.)*SIN(2.*PI*K/160.)
    1 CONTINUE
C-GENERATE THE DFT IN THE DESIRED FREQUENCY RANGE.
      CALL SPCHRP(X,2047,923,0.0,0.03,WORK,LX2,IE)
      IF(IE.NE.0) STOP
C-PLOT THE AMPLITUDE SPECTRUM.
      DO 2 M=0,LX2
        FREQ(M)=0.0+M*(0.03-0.0)/LX2
        AMPL(M)=ABS(X(M))
    2 CONTINUE
      CALL PFILE1(FREQ,AMPL,LX2+1,1,'P1405A')
      STOP
      END
      PROGRAM SPA1406
C-WALSH COEFFICIENTS FOR SEQUENCE LENGTH N=8.
      DIMENSION COEFF(0:7)
      PRINT '('' SEQ. INDEX  --WALSH COEFFICIENTS----------'')'
      DO 2 NSEQ=0,7
        DO 1 K=0,7
          COEFF(K)=SPWLSH(3,NSEQ,K)
    1   CONTINUE
        PRINT '(I6,5X,8F4.0)', NSEQ,COEFF
    2 CONTINUE
      STOP
      END
