function [a,b]=spexpn(x,y)
% [a,b]=spexpn(x,y)
% Fits curve y=a*(b^x) to data in row vectors x and y.
% x(1:N) and y(1:N) must have equal lengths with N>=2.
% Also, the y data must all be >0. See Section 13.3.

N=length(x);
if (N~=length(y)) | (N<2),
   error('SPEXPN: Vector lengths are unequal or <2.');
end
if min(y)<=0,
   error('SPEXPN: An ordinate data point is <= 0.');
end
lgy=log10(y);
[lgb,lga]=splfit(x,lgy);
a=10^lga;
b=10^lgb;
return
