function b=spfirl(L,fcn,iwndo)
% b=spfirl(L,fcn,iwndo)
% FIR lowpass filter design using windowed Fourier series.
% L=order; H(z)=b(1)+b(2)*z^(-1)+...+b(L+1)*z^(-L).
% fcn=cutoff (Hz-s); iwndo=window no.  See Section 8.4.
%  b = Digital filter weight row vector of length L+1.

if L<=0,
   error('SPFIRL: Length L must be greater than 0.');
end
if (iwndo<1)|(iwndo>6),
   error('SPFIRL: iwndo must be in range [1,6].');
end
if (fcn<=0)|(fcn>=0.5),
   error('SPFIRL: fcn must be in range (0,0.5).');
end
b=zeros(1,L+1);
wcn=2*pi*fcn;
dly=L/2;
lim=fix(dly);
if dly==L/2,
   lim=lim-1;
   b(L/2+1)=wcn/pi;
end
for i=0:lim,
   s=i-dly;
   b(i+1)=((sin(wcn*s))/(pi*s))*spwndo(iwndo,L+1,i+1);
   b(L+1-i)=b(i+1);
end
return
