function [a,b]=sppwrc(x,y)
% [a,b]=sppwrc(x,y)
% Fits curve y=a*(x^b) to data in row vectors x and y.
% Lengths of x and y must be equal and >=2.
% x and y data points must all be >0.

N=length(x);
if(length(y)~=N)|(N<2),
   error('SPPWRC: x and y lengths unequal or < 2.');
end
if (min(x)<=0)|(min(y)<=0),
   error('SPPWRC: an x or y data point is <=0.');
end
log_x=log10(x);
log_y=log10(y);
[b,log_a]=splfit(log_x,log_y);
a=10^log_a;
return
