function ux=spunwr(x,flag)
% ux=spunwr(x,flag)
% Phase unwrapping function. See Chapter 14, Section 14.3.
% x=phase vector; ux=unwrapped version of x.
% flag=1(x in radians) or 2(x in degrees).
% Inputs:
%  x    = Sequence of phase angles in radians or degrees, assumed
%         to be outputs of atan2 in the range (-pi,pi) radians.
%  flag = Units flag; 1=radians and 2=degrees.
% Outputs:
%  ux   = x vector, unwrapped.

if flag==1
   angl=pi;
else
   angl=180;
end
cor=0;
for k=1:length(x)-1,
   dx=x(k+1)-(x(k)-cor);
   if abs(dx)>angl
      cor=cor-(abs(2*angl)*sign(dx));
   end
   x(k+1)=x(k+1)+cor;
end
ux=x;
return
