function [a,b]=spxexp(x,y)
% [a,b]=spxexp(x,y)
% Fits y=b*x*exp(a*x) to data in row vectors x and y.
% Lengths of x and y must be equal and >=2.
% x and y data points must all be >0.

N=length(x);
if(length(y)~=N)|(N<2),
   error('SPXEXP: x and y lengths unequal or < 2.');
end
if (min(x)<=0)|(min(y)<=0),
   error('SPXEXP: an x or y data point is <=0.');
end
y_log=log(y)-log(x);
[a,b_log]=splfit(x,y_log);
b=exp(b_log);
return
