% SPA0608:  FIR filtering with function SPFIRF.

% Plot x a sine wave at 1/20 Hz-s in white Gaussian noise.
N=500; randn('seed',123);
x=sin(2*pi*[0:N-1]/20) + sqrt(.5)*randn(1,N);
subplot(2,1,1); plot([0:N-1],x,'w'); grid on;
ylabel('Input x'); title('SPA0608: FIR filtering with SPFIRF');

% Design a narrowband filter to enhance the sine wave.
L=200; iband=3; low=1/20-.01; high=1/20+.01; iwndo=4;
b=spfird(L,iband,low,high,iwndo);

% Filter x and plot the result, y.
y=spfirf(b,x);
subplot(2,1,2); plot([0:N-1],y,'w'); grid on;
xlabel('Sample number'); ylabel('Output y');
