% SPA0609:  Demonstrate the use of SPLFLT.
N=25;
x=[1,zeros(1,N-1)];  past=0;
b=[0.001836,0.007344,0.011016,0.007344,0.001836];
a=[1,-3.0544,3.8291,-2.2925,0.55075];
[kappa,nu]=spltcf(b,a);
for nblk=0:3,
   [y,past]=splflt(kappa,nu,x,past);
   data(nblk*N+1:nblk*N+N)=y;
   x(1)=0;
end
fprintf(' KAPPA COEF = ');...
fprintf('%10.4f',kappa(1:4));...
fprintf('\n    NU COEF = ');...
fprintf('%10.4f',nu(1:5));
fprintf('\n\n SAMPLE    RESPONSE\n')
for k=0:9,
   fprintf('%6g%12.4f\n',k,data(k+1))
end
clg;
plot(data,'w'); grid;...
   title('Figure 6.14');...
   xlabel('Sample Number');...
   ylabel('Amplitude')
