% SPA0702:  Lowpass analog to lowpass digital.
iband=1; fL=1000; fH=0; T=0.0001;
d=[1,0,0]; c=[1,1.41421,1];
fLn=fL*T;
fHn=fH*T;
[b,a]=spfblt(d,c,iband,fLn,fHn);
freq=[0:500]*0.5/500;
amp=abs(spgain(b,a,freq));
fprintf('B(Z) coefficients:  %10.4f%10.4f%10.4f\n',b(1:3));
fprintf('A(Z) coefficients:  %10.4f%10.4f%10.4f\n',a(1:3));
plot([0:500]/100,amp,'w'); grid;...
   title('Figure 7.4');...
   xlabel('Frequency (kHz)');...
   ylabel('Magnitude');
end
