% SPA0708: Design a 5th order highpass Butterworth filter.
iband=2; fl=2500; fh=0; T=0.0001; L=5;
freq=[0:200]*0.5/200;
amp=ones(1,201);
fln=fl*T;
fhn=fh*T;
for k=1:3,
   [d,c]=spbwcf(L,k);
   [b,a]=spfblt(d,c,iband,fln,fhn);
   amp=amp .* abs(spgain(b,a,freq));
   fprintf('Section %2g:',k);...
   if(k < 3),
    fprintf('%8.4f%8.4f%8.4f  %8.4f%8.4f%8.4f\n',b(1:3),a(1:3))
   else
    fprintf('%8.4f%8.4f  %8.4f%8.4f\n',b(1:2),a(1:2))
   end
end
plot([0:200]*5/200,amp,'w'); grid;...
   title('Figure 7.12');...
   xlabel('Frequency (kHz)');...
   ylabel('Amplitude gain');
end
