% SPA0709:  Design 6th order lowpass Chebyshev type I filter.
iband=1; fl=1000; fh=0; T=0.0001; L=6; ep=1;
freq=[0:200]*0.5/200;
amp=ones(1,201);
fln=fl*T;
fhn=fh*T;
for k=1:3,
   [d,c]=spchbi(L,k,ep);
   [b,a]=spfblt(d,c,iband,fln,fhn);
   amp=amp .* abs(spgain(b,a,freq));
   fprintf('Section %2g:',k);...
   fprintf('%8.4f%8.4f%8.4f  %8.4f%8.4f%8.4f\n',b(1:3),a(1:3))
end
plot([0:200]*5/200,amp,'w'); grid;...
   title('Figure 7.15');...
   xlabel('Frequency (kHz)');...
   ylabel('Amplitude gain');
end
