% SPA0712:  Design 8th order bandpass Bessel filter.
iband=3; fl=1500; fh=3500; T=0.0001; L=8; pscl=2.1;
fln=fl*T;
fhn=fh*T;
[d,c]=spbssl(L/2,pscl);
[b,a]=spfblt(d,c,iband,fln,fhn);
freq=[0:200]*0.5/200;
amp=abs(spgain(b,a,freq));
fprintf('B(z) coef.:');...
fprintf('%8.4f',b(1:5));...
fprintf('\n%19.4f%8.4f%8.4f%8.4f',b(6:9));...
fprintf('\nA(z) coef.:');...
fprintf('%8.4f',a(1:5));
fprintf('\n%19.4f%8.4f%8.4f%8.4f\n',a(6:9));...
plot([0:200]*5/200,amp,'w'); grid;...
      title('Figure 7.20');...
      xlabel('Frequency (kHz)');...
      ylabel('Magnitude');
end
