% SPA1005: Spectral comparison of linear versus
%          frequency-preserving interpolation.
t=0:15; ratio=1/10;
x=exp(-t/4) .* sin(2*pi*t/8);
[y1,N1]=splint(x,16,ratio);
[y2,N2]=spzint(x,16,ratio);
%    Plot the interpolated waveforms in figure 1.
figure(1)
subplot(311); plot(t,x, 'wo'); grid;...
 ylabel('x'); title('Original x');
subplot(312); plot((0:N1-1)/10,y1(1:N1),'w'); grid;...
 ylabel('y1'); title('Linear interpolation');
subplot(313); plot((0:N2-1)/10,y2(1:N2),'w'); grid;...
 ylabel('y2'); xlabel('Time (ms)');...
 title('Frequency-preserving interpolation')
Y1=fft(y1,N1); A1=20*log10(abs(Y1(1:(N1+1)/2)));
Y2=fft(y2,160); A2=20*log10(abs(Y2(1:81)));
%    Plot the corresponding spectra in figure 2.
figure(2)
subplot(211); plot((0:(N1-1)/2)/N1,max(-50,A1),'w'); grid;
ylabel('dB'); title('Spectrum of y1');
subplot(212); plot((0:80)/160,max(-50,A2),'w'); grid;
ylabel('dB'); title('Spectrum of y2');
xlabel('Frequency (Hz-s)')
