% SPA1103: Least=squares polynomial fit to noisy data.
x=[0:50]/50;
rand('seed',123);
y=-1 - 5*x - 3*x.^2 + 10*x.^3 +0.4*(rand(1,51)-0.5);
L=5;
[A,c]=spnorm(x,y,L);
fprintf(' Cond(A)=%12.4e\n\n',cond(A));
b=A\c;
fprintf(' POLYNOMIAL COEFFICIENTS IN (11.6):\n');
for i=1:6,
   fprintf(' b(%1g) = %7.2f\n',i-1,b(i));
end
p=b(1)+b(2)*x+b(3)*x.^2+b(4)*x.^3+b(5)*x.^4+b(6)*x.^5;
plot(x,y,'wo',x,p,'w'); grid;
xlabel('x'); ylabel('[yk], p');
title('SPA1103: 5th-order l.s. polynomial fit');
