% SPA1204: Example of adaptive system identification.
N=1001; rand('seed',123);
L=30; mu=0.1; alpha=0; sigma=1; h=zeros(1,L+1);
x=sqrt(12)*(rand(1,N)-0.5);
% The "unknown system" is an FIR bandpass filter with L=21:
sb=spfird(20,3,0.15,0.35,1);
[d,spx,spy]=spfilt(sb,1,x,0,0);
[x,h,px]=spnlms(x,d,h,mu,sigma,alpha,0);
SE=(d-x).^2;
figure(1); plot([0:1000],SE,'-w'); grid;...
   title('Fig. 12.12:  Squared error during convergence');...
   xlabel('Sample Number');...
   ylabel('Epsilon squared');...
sb=[sb,zeros(1,L+1-length(sb))];
figure(2); plot([0:L],h,'-w', [0:L],sb,'*w'); grid;
   title('Fig. 12.13:  Impulse response of system and model');
   xlabel('Sample Number');...
   ylabel('(-)=system;  (*)=model');
