% SPA1402:  Power density spectra using 6 different data windows.

% GENERATE THE TIME SERIES
rand('seed',123);
x=sqrt(12)*(rand(1,1002)-0.5);
for k=3:1002,
   x(k)=x(k)+x(k-1)-0.8*x(k-2);
end

% COMPUTE AND PLOT THE 6 POWER SPECTRA.
y=zeros(6,17);
for iwindo=1:6,
   [pds,nseg]=sppowr(x(3:1002),32,iwindo,0.5);
   y(iwindo,:)=10*log10(pds);
end
hold off
clg
for iwindo=1:6,
   bar([0:16]*0.5/16,y(iwindo,:),'w'); grid on;...
      hold on;...
      title('Figure 14.2');...
      xlabel('Frequency (Sampling Frequency = 1.0)');...
      ylabel('Power Density (dB)');...
end
