% SPA1404: Hilbert trans. of sine wave; 30 samples/period.

% GENERATE THE SINE WAVE PLUS A VERSION DELAYED BY 32 SAMPLES.
t=[0:150];
x =sin(2*pi*t/30);
xd=sin(2*pi*(t-32)/30);

% GENERATE THE HILBERT-TRANSFORMED VERSION USING L=65 WEIGHTS.
b=sphilb(65);
px=0; py=0;
[y,px,py]=spfilt(b,1,x,px,py);
end

% PLOT THE DELAYED AND TRANSFORMED WAVEFORMS.
clg
plot(t,[xd' y'],'w'); grid on;...
   title('Figure 14.9');...
   xlabel('Sample Number (k)');...
   ylabel('Signal Value');
