% SPA1405:  Uses the chirp Z-transform to find the spectrum
% of an exponentially decaying sinusoid, x, over 0<=f<=0.03.
% OBTAIN THE TIME SERIES.
   fid=fopen('c:\matlab\spa\signals\signal_3.txt');
   x=fscanf(fid,'%7d%8d%8d%8d%8d%8d%8d%8d%8d%8d\n',10001)';
   fclose(fid);
%PLOT THE TIME SERIES.
   subplot(2,1,1);
   T=1/44.1; t=0:T:10000*T;
   plot(t,x,'w'); grid on;
      xlabel('Time (ms)'); ylabel('Amplitude');
      title('SPA1405: Amplitude spectrum: 136-182 ms');
% GENERATE THE DFT IN THE DESIRED FREQUENCY RANGE.
   f1=0.05; f2=0.15;
   start=6000;
   X=spchrp(x(start:start+2047),f1*T,f2*T,200);
% PLOT THE AMPLITUDE SPECTRUM.
   subplot(2,1,2);
   freq=f1+[0:199]*(f2-f1)/199;
   plot(freq,abs(X),'w'); grid on;...
      xlabel('Frequency (kHz)');...
      ylabel('Amplitude');
